Package org.apache.commons.net.ftp.parser

# Class NetwareFTPEntryParser

java.lang.Object
org.apache.commons.net.ftp.FTPFileEntryParserImpl
org.apache.commons.net.ftp.parser.RegexFTPFileEntryParserImpl
org.apache.commons.net.ftp.parser.ConfigurableFTPFileEntryParserImpl
org.apache.commons.net.ftp.parser.NetwareFTPEntryParser

All Implemented Interfaces:
  `Configurable`, `FTPFileEntryParser`

public class NetwareFTPEntryParser extends ConfigurableFTPFileEntryParserImpl
Implements `FTPFileEntryParser` and `Configurable` for Netware Systems. Note that some proprietary extensions for Novell-specific operations are not supported. See http://www.novell.com/documentation/nw65/index.html?page=/documentation/nw65/ftp_enu/data/fbhbgcfa.html for more details.

Since:
  1.5
See Also:
  - `Usage instructions.`

- ## Field Summary

  ### Fields inherited from class org.apache.commons.net.ftp.parser.RegexFTPFileEntryParserImpl

  `_matcher_`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NetwareFTPEntryParser()`
  The default constructor for a NetwareFTPEntryParser object.
  `NetwareFTPEntryParser(FTPClientConfig config)`
  This constructor allows the creation of an NetwareFTPEntryParser object with something other than the default configuration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected FTPClientConfig`
  `getDefaultConfiguration()`
  Gets a new default configuration to be used when this class is instantiated without a `FTPClientConfig` parameter being specified.
  `FTPFile`
  `parseFTPEntry(String entry)`
  Parses a line of an NetwareFTP server file listing and converts it into a usable format in the form of an `FTPFile` instance.

  ### Methods inherited from class org.apache.commons.net.ftp.parser.ConfigurableFTPFileEntryParserImpl

  `configure, parseTimestamp`

  ### Methods inherited from class org.apache.commons.net.ftp.parser.RegexFTPFileEntryParserImpl

  `getGroupCnt, getGroupsAsString, group, matches, setRegex, setRegex`

  ### Methods inherited from class org.apache.commons.net.ftp.FTPFileEntryParserImpl

  `preParse, readNextEntry`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### NetwareFTPEntryParser

    public NetwareFTPEntryParser()
    The default constructor for a NetwareFTPEntryParser object.
    Throws:
      `IllegalArgumentException` - Thrown if the regular expression is unparseable. Should not be seen under normal conditions. If it is seen, this is a sign that `REGEX` is not a valid regular expression.

  - ### NetwareFTPEntryParser

    public NetwareFTPEntryParser(FTPClientConfig config)
    This constructor allows the creation of an NetwareFTPEntryParser object with something other than the default configuration.
    Parameters:
      `config` - The `configuration` object used to configure this parser.
    Throws:
      `IllegalArgumentException` - Thrown if the regular expression is unparseable. Should not be seen under normal conditions. If it is seen, this is a sign that `REGEX` is not a valid regular expression.
    Since:
      1.4

- ## Method Details

  - ### getDefaultConfiguration

    protected FTPClientConfig getDefaultConfiguration()
    Gets a new default configuration to be used when this class is instantiated without a `FTPClientConfig` parameter being specified.
    Specified by:
      `getDefaultConfiguration` in class `ConfigurableFTPFileEntryParserImpl`
    Returns:
      the default configuration for this parser.

  - ### parseFTPEntry

    public FTPFile parseFTPEntry(String entry)
    Parses a line of an NetwareFTP server file listing and converts it into a usable format in the form of an `FTPFile` instance. If the file listing line doesn't describe a file, `null` is returned, otherwise a `FTPFile` instance representing the files in the directory is returned.

    Netware file permissions are in the following format: RWCEAFMS, and are explained as follows:

    - S - Supervisor; All rights.
    - R - Read; Right to open and read or execute.
    - W - Write; Right to open and modify.
    - C - Create; Right to create; when assigned to a file, allows a deleted file to be recovered.
    - E - Erase; Right to delete.
    - M - Modify; Right to rename a file and to change attributes.
    - F - File Scan; Right to see directory or file listings.
    - A - Access Control; Right to modify trustee assignments and the Inherited Rights Mask.
    See here for more details
    Parameters:
      `entry` - A line of text from the file listing
    Returns:
      An FTPFile instance corresponding to the supplied entry